'''A Ranger Prestige Class'''

import es, popuplib, dnd, random, math, gamethread
from dnds import dnds

SpellCommands = []

def load():
    dnds.addPrestigeClass('Combat Trapsmith', 'Ranger', 10)

    for command in SpellCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnd/SubScripts/CombatTrapsmith/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnd/SubScripts/CombatTrapsmith/%s'%command)
    
    combattrapsmithinfo = popuplib.create('combattrapsmithinfo')
    combattrapsmithinfo.addline('-{ D&D CS:S - Combat Trapsmith Info }-')
    combattrapsmithinfo.addline(' Required Level: 10 ')
    combattrapsmithinfo.addline('-> 1. Passive Skills')
    combattrapsmithinfo.addline('-> 2. Active Spells/Skills')
    combattrapsmithinfo.addline('-> 8. Back')
    combattrapsmithinfo.addline('0. Exit')
    combattrapsmithinfo.submenu(1, 'combattrapsmithpassive')
    combattrapsmithinfo.submenu(2, 'combattrapsmithspells')
    combattrapsmithinfo.submenu(8, 'Rangerprestigeinfo 1')
    dnds.addPrestigeInformation('Combat Trapsmith', 'combattrapsmithinfo')

    combattrapsmithpassive = popuplib.create('combattrapsmithpassive')
    combattrapsmithpassive.addline('-{ Trapsmith Passive Skills }-')
    combattrapsmithpassive.addline(' Lvl ')
    combattrapsmithpassive.addline(' Lvl ')
    combattrapsmithpassive.addline(' Lvl ')
    combattrapsmithpassive.addline('-> 8. Back')
    combattrapsmithpassive.addline('0. Exit')
    combattrapsmithpassive.submenu(8, 'combattrapsmithinfo')

    combattrapsmithspells = popuplib.create('combattrapsmithspells')
    combattrapsmithspells.addline('-{ Trapsmith Active Skills }-')
    combattrapsmithspells.addline(' Lvl ')
    combattrapsmithspells.addline(' Lvl ')
    combattrapsmithspells.addline(' Lvl ')
    combattrapsmithspells.addline(' Lvl ')
    combattrapsmithspells.addline(' Lvl ')
    combattrapsmithspells.addline('-> 8. Back')
    combattrapsmithspells.addline('0. Exit')
    combattrapsmithspells.submenu(8, 'combattrapsmithinfo')

    combattraps = popuplib.create('Combat Trapsmithcast')
    combattraps.addline('-{ Trapsmith Casting XM XH }-')
    combattraps.addline('-> 1. Poison (Uses Left: 0)')
    combattraps.addline('-> 2. Fiendform 2M')
    combattraps.addline('-> 3. Bear\'s Endurance Mass 3M')
    combattraps.addline('-> 4. Blackfire 1H')
    combattraps.addline('-> 8. Back')
    combattraps.addline('0. Exit')
    combattraps.submenu(8, 'Rangercast')
    combattraps.prepuser = combatCastPrep
    combattraps.menuselect = combatCast
