'''A Warlock Prestige Class'''

import es, popuplib, dnds, random, math, gamethread
from dnds import dnds

SpellCommands = ['vitri', 'retri']

def load():
    dnds.addPrestigeClass('Eldritch Shadow', 'Warlock', 10)

    for command in SpellCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnds/SubScripts/EldritchShadow/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnds/SubScripts/EldritchShadow/%s'%command)
    
    eldritchshadowinfo = popuplib.create('eldritchshadowinfo')
    eldritchshadowinfo.addline('-{ D&D CS:S - Eldritch Shadow Info }-')
    eldritchshadowinfo.addline(' Required Level: 10 ')
    eldritchshadowinfo.addline(' Half Casting Progression ')
    eldritchshadowinfo.addline('-> 1. Passive Skills')
    eldritchshadowinfo.addline('-> 2. Active Spells/Skills')
    eldritchshadowinfo.addline('-> 8. Back')
    eldritchshadowinfo.addline('0. Exit')
    eldritchshadowinfo.submenu(1, 'eldritchshadowpassive')
    eldritchshadowinfo.submenu(2, 'eldritchshadowspells')
    eldritchshadowinfo.submenu(8, 'Wizardprestigeinfo 1')
    dnds.addPrestigeInformation('Eldritch Shadow', 'eldritchshadowinfo')

    eldritchshadowpassive = popuplib.create('eldritchshadowpassive')
    eldritchshadowpassive.addline('-{ Eldritch Shadow Passive Skills }-')
    eldritchshadowpassive.addline(' Lvl 1: Stealth - You are stealthed when walking/crouching')
    eldritchshadowpassive.addline(' Lvl 2: Sneak Attack - Extra damage while stealthed')
    eldritchshadowpassive.addline(' Lvl 3: Eldritch Sniper - Sneak Attack with eldritch blast (1/rnd)')
    eldritchshadowpassive.addline(' Lvl 7: Eldritch Sniper - (2/rnd)')
    eldritchshadowpassive.addline('-> 8. Back')
    eldritchshadowpassive.addline('0. Exit')
    eldritchshadowpassive.submenu(8, 'eldritchshadowinfo')

    eldritchshadowspells = popuplib.create('eldritchshadowspells')
    eldritchshadowspells.addline('-{ Eldritch Shadow Active Skills }-')
    eldritchshadowspells.addline(' Lvl 5: Vitriolic Blast - A blast that deals DOT and ignores spell resistance (vitri)')
    eldritchshadowspells.addline(' Lvl 10: Retributive Invisibility - Vanish from sight (retri)')
    eldritchshadowspells.addline('-> 8. Back')
    eldritchshadowspells.addline('0. Exit')
    eldritchshadowspells.submenu(8, 'eldritchshadowinfo')

    eldritchshadowcast = popuplib.create('Eldritch Shadowcast')
    eldritchshadowcast.addline('-{ Eldritch Shadow Casting }-')
    eldritchshadowcast.addline('-> 1. Vitriolic Blast ')
    eldritchshadowcast.addline('-> 2. Retributive Invisibility ')
    eldritchshadowcast.addline('-> 8. Back')
    eldritchshadowcast.addline('0. Exit')
    eldritchshadowcast.submenu(8, 'Warlockcast')
    eldritchshadowcast.prepuser = eldritchCastPrep
    eldritchshadowcast.menuselect = eldritchCast

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    Key['sniper'] = 0
    if dnds.isPrestige(userid, 'Eldritch Shadow'):
        level = dnds.getLevel(userid, 'Eldritch Shadow')
        Key['color'] -= (195+((level/3)*10))
        if level >= 2:
            Key['Sneak Dice'] += max(level/3, 1)
        if level >= 3:
            Key['sniper'] += 1
        if level >= 7:
            Key['sniper'] += 1

def vitri():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 0, 5, 'Eldritch Shadow'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, vitriRun, (userid))

def vitriRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 2000:
            dnds.Beam1(userid, target, 1, 0, 255, 125)
            damage = random.randrange(5, 30, 5)
            dnds.Damage(target, userid, damage)
            for i in range(1, 4):
                dnds.Delayed(target, i, dnds.Damage, (target, userid, 5))
            es.tell(target, '#multi', 'You have been hit by a Vitriolic Blast')
            es.tell(userid, '#multi', 'You have hit %s with a Vitriolic Blast'%es.getplayername(target))
            Key = dnds.getPlayer(userid)
            if 'sniper' in Key:
                if Key['sniper']:
                    if (Key['stealth on'] and not Key['stealth delay']) or Key['Invisibility']:
                        es.event('initialize', 'sneak_attack')
                        es.event('setint',     'sneak_attack', 'userid', target)
                        es.event('setint',     'sneak_attack', 'attacker', userid)
                        es.event('setint',     'sneak_attack', 'damage', damage)
                        es.event('fire',       'sneak_attack')
                        Key['sniper'] -= 1
            dnds.spellDelay(userid, 8)

def retri():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 0, 10, 'Eldritch Shadow'):
        dnds.spellDelay(userid, 7)
        dnds.Invisibility(userid, 10)
        es.tell(userid, '#multi', 'You have hidden yourself for the next 10 seconds!')

def sneak_attack(ev):
    attacker = int(ev['attacker'])
    userid = int(ev['userid'])
    Key = dnds.getPlayer(attacker)
    if dnds.isPrestige(attacker, 'Eldritch Shadow'):
        dice = Key['Sneak Dice']
        if dice:
            bonus = random.randrange(dice*5, dice*30, 5)
            es.tell(attacker, '#multi', '#defaultYou have dealt %s bonus damage with a sneak attack!'%bonus)
            dnds.Damage(userid, attacker, bonus)

def eldritchCastPrep(userid, popupid):
    popup = popuplib.find(popupid)
    level = dnds.getLevel(userid, 'Warlock')
    Key = dnds.getPlayer(userid)
    if level < 5:
        popup.modline(2, '')
    else:
        popup.modline(2, '-> 1. Vitriolic Blast')
    if level < 10:
        popup.modline(3, '')
    else:
        popup.modline(3, '-> 2. Retributive Invisibility')

def eldritchCast(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'vitri')
    elif choice == 2:
        es.cexec(userid, 'retri')

