'''A Rogue Prestige Class'''

import es, popuplib, dnds, math, random
from dnds import dnds

SpellCommands = ['step']

def load():
    dnds.addPrestigeClass('Ghost Faced Killer', 'Rogue', 10, dnds.Rifles)

    for command in SpellCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnds/SubScripts/GhostFaced/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnds/SubScripts/GhostFaced/%s'%command)
    
    ghostfacedinfo = popuplib.create('ghostfacedinfo')
    ghostfacedinfo.addline('-{ D&D CS:S - Ghost Faced Killer }-')
    ghostfacedinfo.addline(' Required Level: 10')
    ghostfacedinfo.addline(' Weapons: Rifles ')
    ghostfacedinfo.addline(' Continued Sneak, Trap Sense & Stealth Advancement')
    ghostfacedinfo.addline('-> 1. Skills')
    ghostfacedinfo.addline('-> 8. Back')
    ghostfacedinfo.addline('0. Exit')
    ghostfacedinfo.submenu(1, 'ghostfacedskills')
    ghostfacedinfo.submenu(8, 'Rogueprestigeinfo 1')
    dnds.addPrestigeInformation('Ghost Faced Killer', 'ghostfacedinfo')

    ghostfacedskills = popuplib.create('ghostfacedskills')
    ghostfacedskills.addline('-{ Ghost Faced Powers }-')
    ghostfacedskills.addline(' Lvl 1: Ghost Step (1/rnd) - Become invisible for 4 seconds (step)')
    ghostfacedskills.addline(' Lvl 3: Frightful Attack - Your sneak attacks blur the vision of the victim')
    ghostfacedskills.addline(' Lvl 4: Ghost Step (2/rnd)')
    ghostfacedskills.addline(' Lvl 6: Ghost Sight - Your trap sense sees through invisibility and stealth')
    ghostfacedskills.addline(' Lvl 7: Ghost Step (3/rnd)')
    ghostfacedskills.addline(' Lvl 10: Ghost Step (4/rnd)')
    ghostfacedskills.addline('-> 8. Back')
    ghostfacedskills.addline('0. Exit')
    ghostfacedskills.submenu(8, 'ghostfacedinfo')

    dnds.Commands['cast']['Prestiges'].append('Ghost Faced Killer')

    casting = popuplib.create('Ghost Faced Killercast')
    casting.addline('-> 1. Ghost Step (X)')
    casting.prepuser = gfkCastPrep
    casting.menuselect = gfkCast

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    if dnds.isPrestige(userid, 'Ghost Faced Killer'):
        level = dnds.getLevel(userid, 'Ghost Faced Killer')
        Key['color'] -= (level/3)*10
        Key['Sneak Dice'] += max(level/5, 0)
        if level >= 1:
            Key['spells'][1] += 1
        if level >= 4:
            Key['spells'][1] += 1
        if level >= 6:
            Key['thermal invis'] = 1
        if level >= 7:
            Key['spells'][1] += 1
        if level >= 10:
            Key['spells'][1] += 1
        if level >= 2:
            Key['thermal range'] += 120
        if level >= 5:
            Key['thermal range'] += 120
        if level >= 8:
            Key['thermal range'] += 120

def sneak_attack(ev):
    attacker = int(ev['attacker'])
    userid = int(ev['userid'])
    Key = dnds.getPlayer(attacker)
    if dnds.isPrestige(attacker, 'Ghost Faced Killer'):
        #es.msg('is rogue')
        level = dnds.getLevel(attacker, 'Ghost Faced Killer')
        if level >= 3:
            es.server.queuecmd('est_drug %s 6'%userid)

def step():
    userid = es.getcmduserid()
    Key = dnds.getPlayer(userid)
    if Key['spells'][1]:
        if not Key['Invisibility']:
            dnds.Invisibility(userid, 4)
            Key['spells'][1] -= 1
            es.tell(userid, '#multi', 'You are invisible for the next 4 seconds!')
            dnds.Delayed(userid, 4, InvisOffMsg, (userid))
        else:
            es.tell(userid, '#multi', 'You are already invisible!')

def InvisOffMsg(userid):
    Key = dnds.getPlayer(userid)
    if Key['Invisibility']:
        es.tell(userid, '#multi', 'You are visible again.')

def gfkCast(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'step')

def gfkCastPrep(userid, popupid):
    popup = popuplib.find('Ghost Faced Killercast')
    Key = dnds.getPlayer(userid)
    if Key['spells'][1]:
        popup.modline(1, '-> 1. Ghost Step (Uses Left: %s)'%Key['spells'][1])
    else:
        popup.modline(1, ' Ghost Step')
