'''A Class for D&D 3.5 Mod

Notes -
    Cure spell is run from Cleric.py'''

import es, dnds, popuplib, random, gamethread, math
from dnds import dnds

SpellCommands = ['stride', 'bark', 'fang', 'serious']

def load():
    dnds.addClass('Ranger', dnds.ShotGuns+dnds.SMGs+dnds.Grenades+dnds.Pistols+dnds.Rifles+['scout','knife'])

    for command in SpellCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnd/SubScripts/Ranger/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnd/SubScripts/Ranger/%s'%command)

    rangerinfo = popuplib.create('rangerinformation')
    rangerinfo.addline('-{ D&D CS:S - Ranger }-')
    rangerinfo.addline(' Weapons: Shotguns, SMGs, Grenades, Pistols, Rifles, and Scout')
    rangerinfo.addline(' Enter \'cast\' into chat for a casting menu')
    rangerinfo.addline(' Or enter the (keyword) listed to directly cast a spell')
    rangerinfo.addline('-> 1. Passive Powers')
    rangerinfo.addline('-> 2. Casting Powers')
    rangerinfo.addline('-> 7. Play as a Ranger')
    rangerinfo.addline('-> 8. Back')
    rangerinfo.addline('0. Exit')
    rangerinfo.submenu(8, 'classinfo 1')
    rangerinfo.submenu(1, 'rangerpwrsinfo1')
    rangerinfo.submenu(2, 'rangerpwrsinfo2')
    rangerinfo.menuselect = rangerMenuSelect
    dnds.addClassInformation('Ranger', 'rangerinformation')

    pwrsinfo = popuplib.create('rangerpwrsinfo1')
    pwrsinfo.addline('-{ Ranger Passive Powers }-')
    pwrsinfo.addline(' Lvl 1: Track - You can follow those you have hit')
    pwrsinfo.addline(' Lvl 3: Endurance - Regenerate Health')
    pwrsinfo.addline(' Lvl 6: Stealth - When walking/crouching')
    pwrsinfo.addline(' Lvl 12: Evasion - Chance to dodge attacks')
    pwrsinfo.addline(' Lvl 16: Die Hard - 10% Damage Reduction')
    pwrsinfo.addline(' Lvl 20: HIPs - Have an increased chance to stay stealthed while attacking')
    pwrsinfo.addline('-> 8. Back')
    pwrsinfo.addline('0. Exit')
    pwrsinfo.submenu(8, 'rangerinformation')

    pwrsinfo = popuplib.create('rangerpwrsinfo2')
    pwrsinfo.addline('-{ Ranger Casting Powers }-')
    pwrsinfo.addline(' Lvl 4: Long Strider - Increased movement speed for a time (stride)')
    pwrsinfo.addline(' Lvl 8: Cure Wounds - Heal selected ally (cure)')
    pwrsinfo.addline(' Lvl 10: Bark Skin - Selected ally gains DR for a time (bark)')
    pwrsinfo.addline(' Lvl 14: Magic Fang - Select ally gains extra damage (fang)')
    pwrsinfo.addline(' Lvl 18: Cure Serious - Heal selected ally (serious)')
    pwrsinfo.addline('-> 8. Back')
    pwrsinfo.addline('0. Exit')
    pwrsinfo.submenu(8, 'rangerinformation')

    rangercast = popuplib.create('Rangercast')
    rangercast.addline('-{ Ranger Cast  xL xM}-')
    rangercast.addline('-> 1. Long Strider 1L')
    rangercast.addline('-> 2. Cure Wounds 1L')
    rangercast.addline('-> 3. Bark Skin 1M')
    rangercast.addline('-> 4. Magic Fang 1M')
    rangercast.addline('-> 5. Cure Serious 2M')
    rangercast.addline('0. Exit')
    rangercast.prepuser = rangerCastPrep
    rangercast.menuselect = rangerCast

    dnds.Commands['cast']['Classes'].append('Ranger')
    ThermalLoop()

def rangerMenuSelect(userid, choice, popupid):
    if choice == 7:
        Key = dnds.getPlayer(userid)
        Key['delayed']['class'] = 'Ranger'
        es.tell(userid, '#multi', 'You will be a Ranger once the round ends')

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    if dnds.isClass(userid, 'Ranger'):
        level = dnds.getLevel(userid, 'Ranger')
        Key['spells'][1] += level/2
        Key['spells'][2] += level/4
        if level >= 3:
            dnds.Regeneration(userid, 3, 1)
        if level >= 6:
            Key['color'] -= (175+((level/4)*10))
        if level >= 12:
            Key['dodge max damage'] += 100
            Key['dodge percent'] += 10
        if level >= 16:
            Key['damage reduction'] += .1
        if level >= 20:
            Key['HIPs'] = 1

def player_hurt(ev):
    attacker = int(ev['attacker'])
    userid = int(ev['userid'])
    damage = int(float(ev['dmg_health']))
    if attacker:
        if dnds.isClass(attacker, 'Ranger'):
            Key = dnds.getPlayer(attacker)
            level = dnds.getLevel(attacker, 'Ranger')
            if userid not in Key['trackies']:
                Key['trackies'].append(userid)

see_thru_walls_sprite = "effects/strider_bulge_dudv_dx60.vmt"
def ThermalLoop():
    for userid in es.getUseridList():
        if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
            if dnds.isClass(userid, 'Ranger'):
                Key = dnds.getPlayer(userid)
                x,y,z = es.getplayerlocation(userid)
                for id in filter(lambda x:not x == userid and not es.getplayerprop(x, 'CBasePlayer.pl.deadflag'), es.getUseridList()):
                    if id in Key['trackies']:                    
                        x1, y1, z1 = es.getplayerlocation(id)
                        distance = math.sqrt(math.pow((x-x1), 2) + math.pow((y-y1), 2) + math.pow((z-z1), 2))
                        if distance <= 3600 and distance >= 180:
                            alpha = 255 * (180 / distance)
                            if alpha > 255:
                                alpha = 255
                            es.server.queuecmd('est_effect %s %s %s %s %s %s %s %s %s %s'%(11, userid, 0,see_thru_walls_sprite, x1, y1, z1 + 20, .1, 1, int(alpha)))
    gamethread.delayedname(.1, 'ranger_Thermal', ThermalLoop)

def stride():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 1, 4, 'Ranger'):
        dnds.playerMenu(userid, strideSelect, 'Select a player to cast Long Strider on', es.getplayerteam(userid), distance=360, buff='speed')

def strideSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 1, 1, 4, 'Ranger'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            duration = min((dnds.getLevel(userid, 'Ranger')/2)*5, 30)
            dnds.Speed(choice, .15, delay=(duration))
            if choice != userid:
                dnds.giveXp(userid, 10, 'helping an ally')
                es.tell(choice, '#multi', 'You have been granted increased movement by %s for %s seconds'%(es.getplayername(userid), duration))
            es.tell(userid, '#multi', 'You have cast Long Strider on %s'%es.getplayername(choice))
            dnds.Delayed(choice, duration, es.tell, (choice, '#multi', 'Your bonus speed from Long Strider has worn off.'))
            dnds.spellDelay(userid, 5)
            dnds.Buffs(choice, 'speed', duration)
            Key = dnds.getPlayer(userid)
            Key['spells'][1] -= 1
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Long Strider on.'%es.getplayername(choice))

def bark():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 3, 10, 'Ranger'):
        dnds.playerMenu(userid, barkSelect, 'Select a player to cast Shield of Faith on', es.getplayerteam(userid), distance=360, buff='dr')

def barkSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 1, 3, 10, 'Ranger'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            duration = min((dnds.getLevel(userid, 'Ranger')/2)*5, 30)
            Key = dnds.getPlayer(choice)
            Key['damage reduction'] += .2
            dnds.Delayed(choice, duration, barkRemove, (choice))
            if choice != userid:
                dnds.giveXp(userid, 15, 'helping an ally')
                es.tell(choice, '#multi', '%s granted you damage reduction with their Bark Skin for the next %s seconds'%(es.getplayername(userid), duration))
            es.tell(userid, '#multi', 'You have cast Bark Skin on %s for %s seconds'%(es.getplayername(choice), duration))
            dnds.spellDelay(userid, 6)
            dnds.Buffs(choice, 'dr', duration)
            Key = dnds.getPlayer(userid)
            Key['spells'][1] -= 3
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Bark Skin on.'%es.getplayername(choice))

def barkRemove(userid):
    Key = dnds.getPlayer(userid)
    Key['damage reduction'] -= .2
    es.tell(userid, '#multi', 'Your Bark Skin bonus has worn off')

def fang():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 1, 14, 'Ranger'):
        dnds.playerMenu(userid, fangSelect, 'Select a player to cast Magic Fang on', es.getplayerteam(userid), distance=360, buff='damage')

def fangSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 2, 1, 4, 'Ranger'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            dnds.Buff(choice, .3, 15)
            if choice != userid:
                dnds.giveXp(userid, 15, 'helping an ally')
                es.tell(choice, '#multi', 'You have been granted increased damage by %s for 15 seconds'%es.getplayername(userid))
            es.tell(userid, '#multi', 'You have cast Magic Fang on %s'%es.getplayername(choice))
            dnds.Delayed(choice, 15, es.tell, (choice, '#multi', 'Your bonus damage from Magic Fang has worn off.'))
            dnds.Buffs(choice, 'damage', 15)
            dnds.spellDelay(userid, 4)
            Key = dnds.getPlayer(userid)
            Key['spells'][2] -= 1
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Magic Fang on.'%es.getplayername(choice))

def serious():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 2, 18, 'Ranger'):
        dnds.playerMenu(userid, seriousSelect, 'Select a player to cast Cure Serious on', es.getplayerteam(userid), distance=360, extra='health')

def seriousSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 2, 2, 18, 'Ranger'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            dnds.Heal(choice, 45)
            if choice != userid:
                dnds.giveXp(userid, 20, 'helping an ally')
                es.tell(choice, '#multi', 'You have been healed by %s for 45 health'%es.getplayername(userid))
            es.tell(userid, '#multi', 'You have healed %s for 45 health'%es.getplayername(choice))
            dnds.spellDelay(userid, 3)
            Key = dnds.getPlayer(userid)
            Key['spells'][2] -= 2
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Cure Serious on.'%es.getplayername(choice))

def rangerCast(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'stride')
    elif choice == 2:
        es.cexec(userid, 'cure')
    elif choice == 3:
        es.cexec(userid, 'bark')
    elif choice == 4:
        es.cexec(userid, 'fang')
    elif choice == 5:
        es.cexec(userid, 'serious')

def rangerCastPrep(userid, popupid):
    popup = popuplib.find('Rangercast')
    level = dnds.getLevel(userid, 'Ranger')
    Key = dnds.getPlayer(userid)
    popup.modline(1, '-{ Ranger Cast - %sL - %sM }-'%(Key['spells'][1], Key['spells'][2]))
    if level < 4:
        popup.modline(2, '')
    else:
        if Key['spells'][1] < 1:
            popup.modline(2, ' Long Strider')
        else:
            popup.modline(2, '-> 1. Long Strider 1L')
    if level < 8:
        popup.modline(3, '')
    else:
        if Key['spells'][1] < 1:
            popup.modline(3, ' Cure Wounds')
        else:
            popup.modline(3, '-> 2. Cure Wounds 1L')
    if level < 10:
        popup.modline(4, '')
    else:
        if Key['spells'][1] < 3:
            popup.modline(4, ' Bark Skin')
        else:
            popup.modline(4, '-> 3. Bark Skin 3L')
    if level < 14:
        popup.modline(5, '')
    else:
        if Key['spells'][2] < 1:
            popup.modline(5, ' Magic Fang')
        else:
            popup.modline(5, '-> 4. Magic Fang 1M')
    if level < 18:
        popup.modline(6, '')
    else:
        if Key['spells'][2] < 2:
            popup.modline(6, ' Cure Serious')
        else:
            popup.modline(6, '-> 5. Cure Serious 2M')
